=== debian/changelog ===
deepin-draw (5.9.4-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 27 Apr 2021 16:27:26 +0800

deepin-draw (0.0.1-1) unstable; urgency=medium

  * init 

 -- Deepin Packages Builder <packages@deepin.com>  Fri, 07 Jul 2017 15:49:17 +0800
