=== debian/changelog ===
deepin-draw (5.10.6-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Wed, 22 Dec 2021 08:55:41 +0800
