=== debian/control ===
Source: deepin-draw
Section: utils
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: 
 debhelper,
 cmake,
 qtbase5-dev,
 pkg-config,
 libexif-dev,
 libqt5svg5-dev,
 libraw-dev,
 libfreeimage-dev,
 libqt5opengl5-dev,
 libdtkgui-dev,
 qttools5-dev,
 qttools5-dev-tools,
 libdtkwidget-dev,
 libxcb-util0-dev,
 libdtkcore5-bin
Standards-Version: 3.9.8
Homepage: http://www.deepin.org

Package: deepin-draw
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, qt5-image-formats-plugins, deepin-picker-cli
Description: Draw for UOS
 Draw is a lightweight drawing tool for users to freely draw and simply edit images.
