=== debian/changelog ===
deepin-draw (5.10.10-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Tue, 10 May 2022 17:49:58 +0800
