=== debian/changelog ===
deepin-draw (5.11.3-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Wed, 27 Jul 2022 11:32:45 +0800

deepin-draw (0.0.1) unstable; urgency=medium

  * init 

 -- Deepin Packages Builder <packages@deepin.com>  Fri, 07 Jul 2017 15:49:17 +0800
