=== debian/changelog ===
deepin-draw (5.11.6-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Thu, 17 Nov 2022 10:41:59 +0800
