=== debian/control ===
--- 
+++ 
@@ -17,7 +17,9 @@
  qttools5-dev-tools,
  libdtkwidget-dev,
  libxcb-util0-dev,
- libdtkcore5-bin
+ libdtkcore5-bin,
+ libgtest-dev,
+ libgmock-dev
 Standards-Version: 3.9.8
 Homepage: http://www.deepin.org
 
@@ -26,3 +28,4 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}, qt5-image-formats-plugins, deepin-picker-cli
 Description: Draw for UOS
  Draw is a lightweight drawing tool for users to freely draw and simply edit images. 
+Recommends: uos-reporter, deepin-event-log
