## deepin-draw 6.5.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -41,12 +41,10 @@
 endif()
 
 #define install destination
-set(${CMAKE_INSTALL_PREFIX} usr/bin)
-set(PREFIX /usr)
-set(BinDir ${PREFIX}/bin)
-set(TranslationDir ${PREFIX}/share/deepin-draw/translations/)
+include(GNUInstallDirs)
+set(TranslationDir ${CMAKE_INSTALL_DATADIR}/deepin-draw/translations/)
 if(DEEPINDRAW_LOAD_TOOL_PLUGINS AND NOT DEEPINDRAW_LINK_DRAWBASELIB_STATIC)
-    set(PluginDir ${PREFIX}/lib/${CMAKE_LIBRARY_ARCHITECTURE}/deepin-draw/plugins/)
+    set(PluginDir ${CMAKE_INSTALL_LIBDIR}/deepin-draw/plugins/)
     set(PluginTransDir ${TranslationDir}plugins)
 endif()
