=== src/deepin-draw/CMakeLists.txt ===
--- 
+++ 
@@ -22,9 +22,9 @@
 
 install(TARGETS ${PROJECT_NAME}
         EXPORT ${PROJECT_NAME}Targets
-        LIBRARY DESTINATION /usr/lib
-        ARCHIVE DESTINATION lib
-        RUNTIME DESTINATION /usr/bin
+        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
         INCLUDES DESTINATION allHeaders)
 
 # install DBus file:
