=== debian/changelog ===
deepin-draw (6.5.8) unstable; urgency=medium

  * chore: New version 6.5.8.

 -- xiepengfei <xiepengfei@uniontech.com>  Fri, 20 Dec 2024 14:04:06 +0800

deepin-draw (6.5.7) unstable; urgency=medium

  * Update version to 6.5.7

 -- xiepengfei <xiepengfei@uniontech.com>  Sat, 14 Dec 2024 15:12:54 +0800

deepin-draw (6.5.6) unstable; urgency=medium

  * Update version to 6.5.6

 -- renbin <renbin@uniontech.com>  Sat, 30 Nov 2024 18:42:50 +0800

deepin-draw (6.5.5) unstable; urgency=medium

  * Update version to 6.5.5

 -- renbin <renbin@uniontech.com>  Sat, 30 Nov 2024 13:46:23 +0800

deepin-draw (6.5.4) unstable; urgency=medium

  * remove kwayland-shell env 

 -- Liu zheng <liuzheng@uniontech.com>  Mon, 11 Nov 2024 11:00:21 +0800

deepin-draw (6.5.3) unstable; urgency=medium

  * chore: Update linglong build script.

 -- wangrong <wangrong@uniontech.com>  Sat, 19 Oct 2024 14:47:21 +0800

deepin-draw (6.5.2) unstable; urgency=medium

  * chore: Adapt linglong.

 -- wangrong <wangrong@uniontech.com>  Mon, 14 Oct 2024 11:03:39 +0800

deepin-draw (6.5.1) unstable; urgency=medium

  * fix: Resolve the issue of not being able to repeatedly open ddf files(Bug: 270887)

 -- renbin <renbin@uniontech.com>  Fri, 20 Sep 2024 13:11:17 +0800

deepin-draw (6.5.0) unstable; urgency=medium

  * feat: adapt treeland(Influence: Treeland)

 -- renbin <renbin@uniontech.com>  Wed, 21 Aug 2024 15:53:20 +0800

deepin-draw (6.0.11) unstable; urgency=medium

  * feat: add avif and heif image format file support
  * fix: the null pointer reference vulnerability
  * fix: too much latency when drawing on 4k screens
  * fix: compile error

 -- wangyu <wangyu@uniontech.com>  Wed, 10 Jul 2024 11:14:38 +0800

deepin-draw (6.0.10) unstable; urgency=medium

  * chore: Update REUSE date

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 16 Oct 2023 17:05:20 +0800

deepin-draw (6.0.9) unstable; urgency=medium

  * feat:[UI] Adapt compact mode
  * fix: [ui] Export dialog box, select path button, add anti aliasing effect

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 25 Sep 2023 17:13:50 +0800

deepin-draw (6.0.8) unstable; urgency=medium

  * fix: After the home directory is changed, deepin-draw fails to start.

 -- renbin <renbin@uniontech.com>  Wed, 30 Aug 2023 16:34:54 +0800

deepin-draw (6.0.7) unstable; urgency=medium

  * fix: Solve the problem that the image becomes large after saving(Bug: 207563)
  * fix: Fix the problem that the file is too large after the image 
         is saved in tif format(Bug: 207563)

 -- Deepin Packages Builder <packages@deepin.org>  Fri, 21 Jul 2023 14:15:55 +0800

deepin-draw (6.0.6) unstable; urgency=medium

  * fix: Fix button in compact mode.(Bug: 193945)(Influence: TitleBar)
  * fix: Adjust titlebar spacing in compact mode.(Bug: 193945)(Influence: TitleBar)
  * fix: Keep float button align vertical center.(Bug: 193945)(Influence: TitleBar)

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 31 May 2023 13:42:37 +0800

deepin-draw (6.0.4) unstable; urgency=medium

  * update version to 6.0.4

 -- TagBuilder <tagbuilder@deepin.com>  Fri, 10 Mar 2023 10:11:45 +0800
